module     p0_udbar_neepg_d2h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp1jet/1.4/Virtual/
   ! p0_udbar_neepg/helicity1/d2h1l1d.f90
   ! generator: haggies (1.1)
   use p0_udbar_neepg_config, only: ki
   use p0_udbar_neepg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d2
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_udbar_neepg_globalsl1, only: epspow
      use p0_udbar_neepg_kinematics
      use p0_udbar_neepg_abbrevh1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t2 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb2n11+t1*abb2n19+abb2n13*dotproduct(qshift, qshift)+abb2&
         &n14*(spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)&
         &-spvak5k2(4)*qshift(4))+abb2n16*dotproduct(k5, qshift)+abb2n17*(spvak3&
         &k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-spvak3k1(4&
         &)*qshift(4))+abb2n18*(spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spva&
         &k2k1(3)*qshift(3)-spvak2k1(4)*qshift(4))+t1*t2*abb2n12)
         return
      end if
      t3 = spvak5k1(iv1)
      t4 = spvak3k4(iv1)
      if(deg.eq.1) then
         numerator = (k5(iv1)*abb2n16+qshift(iv1)*abb2n15+spvak2k1(iv1)*abb2n18+&
         &spvak3k1(iv1)*abb2n17+spvak5k2(iv1)*abb2n14+t3*abb2n19+t1*t4*abb2n12+t&
         &2*t3*abb2n12)
         return
      end if
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb2n13+spvak3k4(iv2)*t3*abb2n12+spvak&
         &5k1(iv2)*t4*abb2n12)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d2:
   subroutine     reconstruct_d2(coeffs)
      use p0_udbar_neepg_groups, only: tensrec_info_group0
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group0), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_2:
      coeffs%coeffs_2%c0 = derivative(czip)
      coeffs%coeffs_2%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_2%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_2%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_2%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_2%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_2%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_2%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_2%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_2%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_2%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_2%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_2%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_2%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_2%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_2:
   end subroutine reconstruct_d2
!---#] subroutine reconstruct_d2:
end module p0_udbar_neepg_d2h1l1d
